//---------------------------------------------------------------------------
#ifndef App_DataH
#define App_DataH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace App_data {
//---------------------------------------------------------------------------
class TFlashEntry : public TObject
{
private:
	TStrings* FList;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	AnsiString __fastcall GetAsText();
	void __fastcall SetAsText(const AnsiString& AAsText);
	__property TStrings* List = {read=FList};
protected:
public:
	__fastcall TFlashEntry();
	virtual __fastcall ~TFlashEntry();
	virtual AnsiString __fastcall Read(const AnsiString& AKey, const AnsiString& ADefaultValue);
	virtual void __fastcall Write(const AnsiString& AKey, const AnsiString& AValue);
	virtual bool __fastcall Contains(const AnsiString& AKey);
	__property AnsiString AsText = {read=GetAsText, write=SetAsText};
};
//---------------------------------------------------------------------------
class TFlashEntries : public TObject
{
private:
	TStrings* FList;
	static void __fastcall FreeObjects(TStrings* AStrings);
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	AnsiString __fastcall GetAsText();
	void __fastcall SetAsText(const AnsiString& AAsText);
	__property TStrings* List = {read=FList};
protected:
public:
	__fastcall TFlashEntries();
	virtual __fastcall ~TFlashEntries();
	virtual TFlashEntry* __fastcall Read(const AnsiString& AName);
	virtual void __fastcall Write(const AnsiString& AName, TFlashEntry* AEntry);
	virtual bool __fastcall Contains(const AnsiString& AName);
	virtual void __fastcall LoadFromFile(const AnsiString& AFile);
	virtual void __fastcall SaveToFile(const AnsiString& AFile);
	__property AnsiString AsText = {read=GetAsText, write=SetAsText};
};
//---------------------------------------------------------------------------
} // End namespace App_data
using namespace App_data;
//---------------------------------------------------------------------------
#endif

