//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ExamRulesDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppExamRulesDialog* AppExamRulesDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::Field15Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::Field17Exit(TObject* ASender)
{
	Input17;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::Field1AExit(TObject* ASender)
{
	Input1A;
}
//---------------------------------------------------------------------------
TAppExamRulesDialog* __fastcall TAppExamRulesDialog::EnsureCreated()
{
	if(AppExamRulesDialog == NULL) {
		AppExamRulesDialog = new TAppExamRulesDialog(Application);
	}
	return AppExamRulesDialog;
}
//---------------------------------------------------------------------------
TExamRules __fastcall TAppExamRulesDialog::GetDefaultValues()
{
	TExamRules LValues;
	LValues.Shuffle = false;
	LValues.Reverse = false;
	LValues.AutoHint = false;
	LValues.AutoAnswer = false;
	LValues.LimitTime = false;
	LValues.TimeLimit = 0;
	LValues.ChargeRetry = false;
	LValues.RetryInterval = 0;
	return LValues;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::UpdateAccess()
{
	Field16->Enabled = Field15->Checked;
	Field17->Enabled = Field15->Checked;
	Field18->Enabled = Field15->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::HandleInvalidInput(TWinControl* AControl, const AnsiString& AMessage)
{
	ActiveControl = AControl;
	throw EInvalidOperation(AMessage);
}
//---------------------------------------------------------------------------
TExamRules __fastcall TAppExamRulesDialog::GetInputs()
{
	TExamRules LInputs;
	LInputs.Shuffle = Input11;
	LInputs.Reverse = Input12;
	LInputs.AutoHint = Input13;
	LInputs.AutoAnswer = Input14;
	LInputs.LimitTime = Input15;
	LInputs.TimeLimit = Input17;
	LInputs.ChargeRetry = Input18;
	LInputs.RetryInterval = Input1A;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInputs(const TExamRules& AInputs)
{
	Input11 = AInputs.Shuffle;
	Input12 = AInputs.Reverse;
	Input13 = AInputs.AutoHint;
	Input14 = AInputs.AutoAnswer;
	Input15 = AInputs.LimitTime;
	Input17 = AInputs.TimeLimit;
	Input18 = AInputs.ChargeRetry;
	Input1A = AInputs.RetryInterval;
	UpdateAccess();
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::GetInput11()
{
	return Field11->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput11(bool AInput11)
{
	Field11->Checked = AInput11;
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::GetInput12()
{
	return Field12->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput12(bool AInput12)
{
	Field12->Checked = AInput12;
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::GetInput13()
{
	return Field13->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput13(bool AInput13)
{
	Field13->Checked = AInput13;
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::GetInput14()
{
	return Field14->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput14(bool AInput14)
{
	Field14->Checked = AInput14;
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::GetInput15()
{
	return Field15->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput15(bool AInput15)
{
	Field15->Checked = AInput15;
}
//---------------------------------------------------------------------------
int __fastcall TAppExamRulesDialog::GetInput17()
{
	int LInput;
	if(!TryStrToInt(Field17->Text, LInput) || LInput < 0) {
		HandleInvalidInput(Field17, "Specify an integer greater than or equal to zero.");
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput17(int AInput17)
{
	Field17->Text = AInput17;
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::GetInput18()
{
	return Field18->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput18(bool AInput18)
{
	Field18->Checked = AInput18;
}
//---------------------------------------------------------------------------
int __fastcall TAppExamRulesDialog::GetInput1A()
{
	int LInput;
	if(!TryStrToInt(Field1A->Text, LInput) || LInput < 0) {
		HandleInvalidInput(Field1A, "Specify an integer greater than or equal to zero.");
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppExamRulesDialog::SetInput1A(int AInput1A)
{
	Field1A->Text = AInput1A;
}
//---------------------------------------------------------------------------
__fastcall TAppExamRulesDialog::TAppExamRulesDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(GetDefaultValues())
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppExamRulesDialog::~TAppExamRulesDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TAppExamRulesDialog::Execute()
{
	Inputs = Values;
	ActiveControl = NULL;
	SelectFirst();
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

