//---------------------------------------------------------------------------
#ifndef App_FileHandlerH
#define App_FileHandlerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "App_Handlers.h"
#include "App_Exams.h"
namespace App_cards { class TFlashDeck; } using namespace App_cards;
namespace App_filehistory { class TFileHistory; } using namespace App_filehistory;
namespace App_views { class TMainView; } using namespace App_views;
namespace Dialogs { class TOpenDialog; } using namespace Dialogs;
//---------------------------------------------------------------------------
namespace App_filehandler {
//---------------------------------------------------------------------------
class TFileHandler : public THandler
{
private:
	static const AnsiString ProgramTitle;
	static const AnsiString FileHistoryFile;
	AnsiString FFile;
	TFileHistory* FFileHistory;
	TFlashDeck* FDeck;
	TExam* FExam;
	TExamRules FExamRules;
	TMainView* FMainView;
	TOpenDialog* FOpenDialog;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall OpenFile(const AnsiString& AFile);
	void __fastcall ExamStart(TObject* ASender);
	void __fastcall ExamEnd(TObject* ASender);
	void __fastcall ExamProgress(TObject* ASender);
	void __fastcall ExamShowQuestion(TObject* ASender);
	void __fastcall ExamShowHint(TObject* ASender);
	void __fastcall ExamShowAnswer(TObject* ASender);
	void __fastcall ExamTimeUp(TObject* ASender);
	void __fastcall SetFile(const AnsiString& AFile);
	__property TFileHistory* FileHistory = {read=FFileHistory};
	__property TFlashDeck* Deck = {read=FDeck};
	__property TExam* Exam = {read=FExam};
	__property TMainView* MainView = {read=FMainView};
	__property TOpenDialog* OpenDialog = {read=FOpenDialog};
protected:
public:
	__fastcall TFileHandler(TMainView* AMainView);
	virtual __fastcall ~TFileHandler();
	virtual void __fastcall Open();
	virtual void __fastcall Open(const AnsiString& AFile);
	virtual bool __fastcall CanOpen();
	virtual void __fastcall Reopen();
	virtual bool __fastcall CanReopen();
	virtual void __fastcall Close();
	virtual bool __fastcall CanClose();
	virtual void __fastcall DropFiles(const TStringDynArray& AFiles);
	virtual bool __fastcall CanDropFiles();
	virtual void __fastcall ShowFileHistory();
	virtual bool __fastcall CanShowFileHistory();
	virtual void __fastcall CopyDeck();
	virtual bool __fastcall CanCopyDeck();
	virtual void __fastcall CopyInformation();
	virtual bool __fastcall CanCopyInformation();
	virtual void __fastcall CopyCards();
	virtual bool __fastcall CanCopyCards();
	virtual void __fastcall CopyCurrentCard();
	virtual bool __fastcall CanCopyCurrentCard();
	virtual void __fastcall CopyMessages();
	virtual bool __fastcall CanCopyMessages();
	virtual void __fastcall ShowInformation();
	virtual bool __fastcall CanShowInformation();
	virtual void __fastcall Start();
	virtual bool __fastcall CanStart();
	virtual void __fastcall Stop();
	virtual bool __fastcall CanStop();
	virtual void __fastcall Proceed();
	virtual bool __fastcall CanProceed();
	virtual void __fastcall Retry();
	virtual bool __fastcall CanRetry();
	virtual void __fastcall ShowHint();
	virtual bool __fastcall CanShowHint();
	virtual void __fastcall GoBack();
	virtual bool __fastcall CanGoBack();
	virtual void __fastcall GoForward();
	virtual bool __fastcall CanGoForward();
	virtual void __fastcall SetExamRules(const TExamRules& AExamRules);
	virtual bool __fastcall CanSetExamRules();
	virtual void __fastcall ShowExamRules();
	virtual bool __fastcall CanShowExamRules();
	virtual bool __fastcall IsOpen();
	virtual bool __fastcall IsPlaying();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile);
	__property AnsiString File = {read=FFile};
	__property TExamRules ExamRules = {read=FExamRules};
};
//---------------------------------------------------------------------------
} // End namespace App_filehandler
using namespace App_filehandler;
//---------------------------------------------------------------------------
#endif

