//---------------------------------------------------------------------------
#ifndef App_FileHistoryH
#define App_FileHistoryH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace App_filehistory {
//---------------------------------------------------------------------------
class TFileHistory : public TObject
{
private:
	TStrings* FList;
	int FLimit;
	AnsiString FFile;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall Load();
	void __fastcall Save();
	AnsiString __fastcall GetItem(int AIndex);
	int __fastcall GetCount();
	void __fastcall SetCount(int ACount);
	void __fastcall SetLimit(int ALimit);
	__property TStrings* List = {read=FList};
protected:
public:
	__fastcall TFileHistory(const AnsiString& AFile);
	virtual __fastcall ~TFileHistory();
	virtual int __fastcall Add(const AnsiString& AItem);
	virtual int __fastcall Remove(const AnsiString& AItem);
	virtual void __fastcall Delete(int AIndex);
	virtual void __fastcall Clear();
	virtual int __fastcall Find(const AnsiString& AItem);
	virtual void __fastcall Reload();
	virtual void __fastcall UpdateFile();
	__property AnsiString Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount, write=SetCount};
	__property int Limit = {read=FLimit, write=SetLimit};
	__property AnsiString File = {read=FFile};
};
//---------------------------------------------------------------------------
} // End namespace App_filehistory
using namespace App_filehistory;
//---------------------------------------------------------------------------
#endif

