//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Clipbrd.hpp>
#include <Math.hpp>
#include "App_FileHistory.h"
#include "App_FileHistoryDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppFileHistoryDialog* AppFileHistoryDialog = NULL;
//---------------------------------------------------------------------------
namespace App_filehistorydialog {
//---------------------------------------------------------------------------
bool __fastcall TAppFileHistoryValues::operator ==(const TAppFileHistoryValues& AOther) const
{
	if(&AOther == this) {
		return true;
	}
	return
		FileHistory == AOther.FileHistory &&
		Index == AOther.Index;
}
//---------------------------------------------------------------------------
bool __fastcall TAppFileHistoryValues::operator !=(const TAppFileHistoryValues& AOther) const
{
	return !(*this == AOther);
}
//---------------------------------------------------------------------------
} // End namespace App_filehistorydialog
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::NewActionExecute(TObject* ASender)
{
	if(Application->MessageBox(
		"The program clears the list.",
		Application->Title.c_str(),
		MB_OKCANCEL | MB_ICONEXCLAMATION | MB_SETFOREGROUND) != IDOK) {
		Abort();
	}
	Values.FileHistory->Clear();
	Values.FileHistory->UpdateFile();
	Inputs = Values;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::NewActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = Field11->Items->Count > 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::CopyActionExecute(TObject* ASender)
{
	Clipboard()->AsText = Values.FileHistory->Items[Field11->ItemIndex];
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::CopyActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = Field11->ItemIndex >= 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::DeleteActionExecute(TObject* ASender)
{
	if(Application->MessageBox(
		"The program deletes the selected item.",
		Application->Title.c_str(),
		MB_OKCANCEL | MB_ICONEXCLAMATION | MB_SETFOREGROUND) != IDOK) {
		Abort();
	}
	Values.FileHistory->Delete(Field11->ItemIndex);
	Values.FileHistory->UpdateFile();
	Inputs = Values;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::DeleteActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = Field11->ItemIndex >= 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::PackActionExecute(TObject* ASender)
{
	if(Application->MessageBox(
		"The program deletes non-existent files from the list.",
		Application->Title.c_str(),
		MB_OKCANCEL | MB_ICONEXCLAMATION | MB_SETFOREGROUND) != IDOK) {
		Abort();
	}
	int LOldCount = Values.FileHistory->Count;
	for(int LI = 0; LI < Values.FileHistory->Count; ++LI) {
		if(!FileExists(Values.FileHistory->Items[LI])) {
			Values.FileHistory->Delete(LI--);
		}
	}
	if(Values.FileHistory->Count == LOldCount) {
		return;
	}
	Values.FileHistory->UpdateFile();
	Inputs = Values;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::PackActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = Field11->Items->Count > 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::ExploreActionExecute(TObject* ASender)
{
	AnsiString LFile = ExtractFilePath(Values.FileHistory->Items[Field11->ItemIndex]);
	SHELLEXECUTEINFO LInfo = {0};
	LInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	LInfo.fMask = 0;
	LInfo.lpVerb = "explore";
	LInfo.lpFile = LFile.c_str();
	LInfo.nShow = SW_SHOW;
	ShellExecuteEx(&LInfo);
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::ExploreActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = Field11->ItemIndex >= 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::Field11Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::Field11DblClick(TObject* ASender)
{
	Button1->Click();
}
//---------------------------------------------------------------------------
TAppFileHistoryDialog* __fastcall TAppFileHistoryDialog::EnsureCreated()
{
	if(AppFileHistoryDialog == NULL) {
		AppFileHistoryDialog = new TAppFileHistoryDialog(Application);
	}
	return AppFileHistoryDialog;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppFileHistoryDialog::DescribeItem(int AIndex, const AnsiString& AFile)
{
	return AnsiString().sprintf(
		"%d. \"%s\" (\"%s\")",
		AIndex,
		ExtractFileName(AFile).c_str(),
		AFile.c_str());
}
//---------------------------------------------------------------------------
TAppFileHistoryValues __fastcall TAppFileHistoryDialog::GetDefaultValues()
{
	TAppFileHistoryValues LValues;
	LValues.Index = -1;
	return LValues;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::UpdateAccess()
{
	for(int LI = 0; LI < ActionList1->ActionCount; ++LI) {
		TContainedAction* LAction = ActionList1->Actions[LI];
		if(LAction->OnUpdate != NULL) {
			LAction->OnUpdate(LAction);
		}
	}
	Button1->Enabled = Input11 >= 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::HandleInvalidInput(TWinControl* AControl, const AnsiString& AMessage)
{
	ActiveControl = AControl;
	throw EInvalidOperation(AMessage);
}
//---------------------------------------------------------------------------
TAppFileHistoryValues __fastcall TAppFileHistoryDialog::GetInputs()
{
	TAppFileHistoryValues LInputs;
	LInputs.FileHistory = Values.FileHistory;
	LInputs.Index = Input11;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::SetInputs(const TAppFileHistoryValues& AInputs)
{
	Field11->Items->BeginUpdate();
	try {
		Field11->Items->Clear();
		Field11->ScrollWidth = 0;
		for(int LI = 0; LI < AInputs.FileHistory->Count; ++LI) {
			int LIndex = Field11->Items->Add(DescribeItem(LI + 1, AInputs.FileHistory->Items[LI]));
			Field11->ScrollWidth = Math::Max(
				Field11->ScrollWidth,
				Field11->Canvas->TextWidth(Field11->Items->Strings[LIndex]));
		}
		Input11 = AInputs.Index;
	}
	catch(...) {
		Field11->Items->EndUpdate();
		throw;
	}
	Field11->Items->EndUpdate();
	UpdateAccess();
}
//---------------------------------------------------------------------------
int __fastcall TAppFileHistoryDialog::GetInput11()
{
	return Field11->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TAppFileHistoryDialog::SetInput11(int AInput11)
{
	if(AInput11 == Input11) {
		return;
	}
	Field11->ItemIndex = EnsureRange(AInput11, -1, Field11->Items->Count - 1);
	UpdateAccess();
}
//---------------------------------------------------------------------------
__fastcall TAppFileHistoryDialog::TAppFileHistoryDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(GetDefaultValues())
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppFileHistoryDialog::~TAppFileHistoryDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TAppFileHistoryDialog::Execute()
{
	Inputs = Values;
	ActiveControl = NULL;
	SelectFirst();
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

