//---------------------------------------------------------------------------
#ifndef App_FileHistoryDialogH
#define App_FileHistoryDialogH
//---------------------------------------------------------------------------
#include <ActnList.hpp>
#include <Buttons.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <Menus.hpp>
#include <StdCtrls.hpp>
namespace App_filehistory { class TFileHistory; } using namespace App_filehistory;
//---------------------------------------------------------------------------
namespace App_filehistorydialog {
//---------------------------------------------------------------------------
struct TAppFileHistoryValues
{
	TFileHistory* FileHistory;
	int Index;
	bool __fastcall operator ==(const TAppFileHistoryValues& AOther) const;
	bool __fastcall operator !=(const TAppFileHistoryValues& AOther) const;
};
//---------------------------------------------------------------------------
} // End namespace App_filehistorydialog
using namespace App_filehistorydialog;
//---------------------------------------------------------------------------
class TAppFileHistoryDialog : public TForm
{
__published:
	TAction* CopyAction;
	TAction* DeleteAction;
	TAction* ExploreAction;
	TAction* NewAction;
	TAction* PackAction;
	TActionList* ActionList1;
	TButton* Button1;
	TButton* Button2;
	TGroupBox* Field1;
	TLabel* Field16;
	TListBox* Field11;
	TMenuItem* MenuItem11;
	TMenuItem* MenuItem12;
	TMenuItem* MenuItem13;
	TMenuItem* MenuItem14;
	TMenuItem* MenuItem15;
	TMenuItem* MenuItem16;
	TMenuItem* MenuItem17;
	TPopupMenu* PopupMenu1;
	TSpeedButton* Field12;
	TSpeedButton* Field13;
	TSpeedButton* Field14;
	TSpeedButton* Field15;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall ActionList1Update(TBasicAction* AAction, bool& AHandled);
	void __fastcall NewActionExecute(TObject* ASender);
	void __fastcall NewActionUpdate(TObject* ASender);
	void __fastcall CopyActionExecute(TObject* ASender);
	void __fastcall CopyActionUpdate(TObject* ASender);
	void __fastcall DeleteActionExecute(TObject* ASender);
	void __fastcall DeleteActionUpdate(TObject* ASender);
	void __fastcall PackActionExecute(TObject* ASender);
	void __fastcall PackActionUpdate(TObject* ASender);
	void __fastcall ExploreActionExecute(TObject* ASender);
	void __fastcall ExploreActionUpdate(TObject* ASender);
	void __fastcall Field11Click(TObject* ASender);
	void __fastcall Field11DblClick(TObject* ASender);
public:
	static TAppFileHistoryDialog* __fastcall EnsureCreated();
private:
	TAppFileHistoryValues FValues;
	static AnsiString __fastcall DescribeItem(int AIndex, const AnsiString& AFile);
	static TAppFileHistoryValues __fastcall GetDefaultValues();
	void __fastcall UpdateAccess();
	void __fastcall HandleInvalidInput(TWinControl* AControl, const AnsiString& AMessage);
	TAppFileHistoryValues __fastcall GetInputs();
	void __fastcall SetInputs(const TAppFileHistoryValues& AInputs);
	int __fastcall GetInput11();
	void __fastcall SetInput11(int AInput11);
	__property TAppFileHistoryValues Inputs = {read=GetInputs, write=SetInputs};
	__property int Input11 = {read=GetInput11, write=SetInput11};
protected:
public:
	__fastcall TAppFileHistoryDialog(TComponent* AOwner);
	virtual __fastcall ~TAppFileHistoryDialog();
	virtual bool __fastcall Execute();
	__property TAppFileHistoryValues Values = {read=FValues, write=FValues};
};
//---------------------------------------------------------------------------
extern PACKAGE TAppFileHistoryDialog* AppFileHistoryDialog;
//---------------------------------------------------------------------------
#endif

