//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <IniFiles.hpp>
#include "App_HelpHandler.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_helphandler {
//---------------------------------------------------------------------------
const AnsiString THelpHandler::HelpFile = ExtractFilePath(Application->ExeName) + "Help\\index.html";
const AnsiString THelpHandler::About = "Flashexam 1.0.0\r\n\r\nCopyright (C) 2012 Moochos. All rights reserved.";
//---------------------------------------------------------------------------
__fastcall THelpHandler::THelpHandler() :
	THandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall THelpHandler::~THelpHandler()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowContents()
{
	if(!CanShowContents()) {
		HandleFeatureUnavailable();
	}
	if(Application->MessageBox(
		"The program opens the offline help.",
		Application->Title.c_str(),
		MB_OKCANCEL | MB_ICONWARNING | MB_SETFOREGROUND) != IDOK) {
		Abort();
	}
	SHELLEXECUTEINFO LInfo = {0};
	LInfo.cbSize = sizeof(SHELLEXECUTEINFO);
	LInfo.fMask = SEE_MASK_FLAG_NO_UI;
	LInfo.lpVerb = "open";
	LInfo.lpFile = HelpFile.c_str();
	LInfo.nShow = SW_SHOW;
	if(!ShellExecuteEx(&LInfo)) {
		throw EHandlerError("The program could not open the help.");
	}
}
//---------------------------------------------------------------------------
bool __fastcall THelpHandler::CanShowContents()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::ShowAbout()
{
	if(!CanShowAbout()) {
		HandleFeatureUnavailable();
	}
	Application->MessageBox(
		About.c_str(),
		Application->Title.c_str(),
		MB_OK | MB_SETFOREGROUND);
}
//---------------------------------------------------------------------------
bool __fastcall THelpHandler::CanShowAbout()
{
	return true;
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::LoadSettings(TMemIniFile* AFile)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall THelpHandler::SaveSettings(TMemIniFile* AFile)
{
	// Do nothing
}
//---------------------------------------------------------------------------
} // End namespace App_helphandler
//---------------------------------------------------------------------------

