//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_MainForm.h"
#include "Moa_AutoPointers.h"
#include "Moa_FileDrop.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAppMainForm* AppMainForm = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(FileCloseAction->Enabled) {
		FileCloseAction->Execute();
	}
	SaveSettings();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionList1Execute(TBasicAction* AAction, bool& AHandled)
{
	if(AAction->OnExecute == NULL) {
		return;
	}
	TCursor LCursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
	try {
		try {
			AAction->OnExecute(AAction);
			AHandled = true;
		}
		catch(...) {
			UpdateNotifier->Invalidate();
			throw;
		}
		UpdateNotifier->Invalidate();
	}
	catch(...) {
		Screen->Cursor = LCursor;
		throw;
	}
	Screen->Cursor = LCursor;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileOpenActionExecute(TObject* ASender)
{
	FileHandler->Open();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileOpenActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanOpen();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileReopenActionExecute(TObject* ASender)
{
	FileHandler->Reopen();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileReopenActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanReopen();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileHistoryActionExecute(TObject* ASender)
{
	FileHandler->ShowFileHistory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileHistoryActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanShowFileHistory();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileExitActionExecute(TObject* ASender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileExitActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileCloseActionExecute(TObject* ASender)
{
	FileHandler->Close();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileCloseActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanClose();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileDropFilesActionExecute(TObject* ASender)
{
	FileHandler->DropFiles(DroppedFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::FileDropFilesActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanDropFiles();
	::DragAcceptFiles(Handle, FileHandler->CanDropFiles());
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataDeckActionExecute(TObject* ASender)
{
	FileHandler->CopyDeck();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataDeckActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanCopyDeck();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataInformationActionExecute(TObject* ASender)
{
	FileHandler->CopyInformation();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataInformationActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanCopyInformation();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataCardsActionExecute(TObject* ASender)
{
	FileHandler->CopyCards();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataCardsActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanCopyCards();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataCurrentCardActionExecute(TObject* ASender)
{
	FileHandler->CopyCurrentCard();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyDataCurrentCardActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanCopyCurrentCard();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyMessagesActionExecute(TObject* ASender)
{
	FileHandler->CopyMessages();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditCopyMessagesActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanCopyMessages();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditInformationActionExecute(TObject* ASender)
{
	FileHandler->ShowInformation();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::EditInformationActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanShowInformation();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ViewToolbarActionExecute(TObject* ASender)
{
	TControlOptions LControlOptions = ViewHandler->ControlOptions;
	LControlOptions.ShowToolbar = !LControlOptions.ShowToolbar;
	ViewHandler->SetControlOptions(LControlOptions);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ViewToolbarActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewHandler->ControlOptions.ShowToolbar;
	LAction->Enabled = ViewHandler->CanSetControlOptions();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ViewStatusBarActionExecute(TObject* ASender)
{
	TControlOptions LControlOptions = ViewHandler->ControlOptions;
	LControlOptions.ShowToolbar = !LControlOptions.ShowStatusBar;
	ViewHandler->SetControlOptions(LControlOptions);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ViewStatusBarActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = ViewHandler->ControlOptions.ShowStatusBar;
	LAction->Enabled = ViewHandler->CanSetControlOptions();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ViewCustomizeActionExecute(TObject* ASender)
{
	ViewHandler->Customize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ViewCustomizeActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ViewHandler->CanCustomize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamStartActionExecute(TObject* ASender)
{
	FileHandler->Start();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamStartActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanStart();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamStopActionExecute(TObject* ASender)
{
	FileHandler->Stop();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamStopActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanStop();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamMoveGoBackActionExecute(TObject* ASender)
{
	FileHandler->GoBack();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamMoveGoBackActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanGoBack();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamMoveGoForwardActionExecute(TObject* ASender)
{
	FileHandler->GoForward();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamMoveGoForwardActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanGoForward();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesShuffleActionExecute(TObject* ASender)
{
	TExamRules LExamRules = FileHandler->ExamRules;
	LExamRules.Shuffle = !LExamRules.Shuffle;
	FileHandler->SetExamRules(LExamRules);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesShuffleActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = FileHandler->ExamRules.Shuffle;
	LAction->Enabled = FileHandler->CanSetExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesReverseActionExecute(TObject* ASender)
{
	TExamRules LExamRules = FileHandler->ExamRules;
	LExamRules.Reverse = !LExamRules.Reverse;
	FileHandler->SetExamRules(LExamRules);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesReverseActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = FileHandler->ExamRules.Reverse;
	LAction->Enabled = FileHandler->CanSetExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesAutoHintActionExecute(TObject* ASender)
{
	TExamRules LExamRules = FileHandler->ExamRules;
	LExamRules.AutoHint = !LExamRules.AutoHint;
	FileHandler->SetExamRules(LExamRules);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesAutoHintActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = FileHandler->ExamRules.AutoHint;
	LAction->Enabled = FileHandler->CanSetExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesAutoAnswerActionExecute(TObject* ASender)
{
	TExamRules LExamRules = FileHandler->ExamRules;
	LExamRules.AutoAnswer = !LExamRules.AutoAnswer;
	FileHandler->SetExamRules(LExamRules);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesAutoAnswerActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = FileHandler->ExamRules.AutoAnswer;
	LAction->Enabled = FileHandler->CanSetExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesLimitTimeActionExecute(TObject* ASender)
{
	TExamRules LExamRules = FileHandler->ExamRules;
	LExamRules.LimitTime = !LExamRules.LimitTime;
	FileHandler->SetExamRules(LExamRules);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesLimitTimeActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Checked = FileHandler->ExamRules.LimitTime;
	LAction->Enabled = FileHandler->CanSetExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesDetailsActionExecute(TObject* ASender)
{
	FileHandler->ShowExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRulesDetailsActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanShowExamRules();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamProceedActionExecute(TObject* ASender)
{
	FileHandler->Proceed();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamProceedActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanProceed();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamHintActionExecute(TObject* ASender)
{
	FileHandler->ShowHint();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamHintActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanShowHint();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRetryActionExecute(TObject* ASender)
{
	FileHandler->Retry();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ExamRetryActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->CanRetry();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ToolsOpenWithEditorActionExecute(TObject* ASender)
{
	ToolsHandler->OpenWithEditor(FileHandler->File);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ToolsOpenWithEditorActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = FileHandler->IsOpen() && ToolsHandler->CanOpenWithEditor();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ToolsCreateTemplateActionExecute(TObject* ASender)
{
	ToolsHandler->CreateTemplate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ToolsCreateTemplateActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ToolsHandler->CanCreateTemplate();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ToolsOptionsActionExecute(TObject* ASender)
{
	ToolsHandler->ShowOptions();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::ToolsOptionsActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ToolsHandler->CanShowOptions();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HelpContentsActionExecute(TObject* ASender)
{
	HelpHandler->ShowContents();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HelpContentsActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpHandler->CanShowContents();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HelpAboutActionExecute(TObject* ASender)
{
	HelpHandler->ShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HelpAboutActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = HelpHandler->CanShowAbout();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SettingsLoadActionExecute(TObject* ASender)
{
	SettingsHandler->Load();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SettingsLoadActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = SettingsHandler->CanLoad();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SettingsSaveActionExecute(TObject* ASender)
{
	SettingsHandler->Save();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SettingsSaveActionUpdate(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = SettingsHandler->CanSave();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Initialize()
{
	try {
		FMainView = new TMainView(this, StaticText1, StatusBar1);
		FMainView->Status = "Ready to open a deck";
		FFileHandler = new TFileHandler(FMainView);
		FViewHandler = new TViewHandler(this, ToolBar1, StatusBar1, StaticText1);
		FToolsHandler = new TToolsHandler();
		FHelpHandler = new THelpHandler();
		FSettingsHandler = new TSettingsHandler();
		FSettingsHandler->Register(FFileHandler);
		FSettingsHandler->Register(FViewHandler);
		FSettingsHandler->Register(FToolsHandler);
		FSettingsHandler->Register(FHelpHandler);
		FSettingsHandler->Register(FSettingsHandler);
		FUpdateNotifier = new TUpdateNotifier();
		FUpdateNotifier->OnInvalidate = UpdateNotifierInvalidate;
		FUpdateNotifier->OnUpdate = UpdateNotifierUpdate;
		FUpdateNotifier->Invalidate();
		::PostMessage(Handle, WM_APP_HANDLECOMMANDLINEPARAMETERS, 0, 0);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::Uninitialize()
{
	delete FUpdateNotifier;
	FUpdateNotifier = NULL;

	delete FSettingsHandler;
	FSettingsHandler = NULL;

	delete FHelpHandler;
	FHelpHandler = NULL;

	delete FToolsHandler;
	FToolsHandler = NULL;

	delete FViewHandler;
	FViewHandler = NULL;

	delete FFileHandler;
	FFileHandler = NULL;

	delete FMainView;
	FMainView = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleCommandLineParameters()
{
	if(ParamCount() == 0) {
		return;
	}
	TStringDynArray LFiles;
	LFiles.Length = ParamCount();
	for(int LI = 0; LI < LFiles.Length; ++LI) {
		LFiles[LI] = ParamStr(LI + 1);
	}
	HandleDroppedFiles(LFiles);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::HandleDroppedFiles(const TStringDynArray& AFiles)
{
	FDroppedFiles = AFiles;
	try {
		FileDropFilesAction->Execute();
	}
	catch(...) {
		FDroppedFiles.Length = 0;
		throw;
	}
	FDroppedFiles.Length = 0;
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateAccess()
{
	for(int LI = 0; LI < ActionList1->ActionCount; ++LI) {
		TContainedAction* LAction = ActionList1->Actions[LI];
		if(LAction->OnUpdate != NULL) {
			LAction->OnUpdate(LAction);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateNotifierInvalidate(TObject* ASender)
{
	::PostMessage(Handle, WM_APP_UPDATEACCESS, 0, 0);
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::UpdateNotifierUpdate(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::WMAppHandleCommandLineParameters(TMessage& AMessage)
{
	HandleCommandLineParameters();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::WMAppUpdateAccess(TMessage& AMessage)
{
	UpdateNotifier->Update();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::WMDropFiles(TMessage& AMessage)
{
	TFileDrop LFileDrop(AMessage, true);
	::SetForegroundWindow(Handle);
	TStringDynArray LFiles;
	LFiles.Length = LFileDrop.Count;
	for(int LI = 0; LI < LFiles.Length; ++LI) {
		LFiles[LI] = LFileDrop.Files[LI];
	}
	LFileDrop.Finish();
	HandleDroppedFiles(LFiles);
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::TAppMainForm(TComponent* AOwner) :
	TForm(AOwner),
	FMainView(NULL),
	FFileHandler(NULL),
	FViewHandler(NULL),
	FToolsHandler(NULL),
	FHelpHandler(NULL),
	FSettingsHandler(NULL),
	FUpdateNotifier(NULL),
	FDroppedFiles()
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TAppMainForm::~TAppMainForm()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::LoadSettings()
{
	SettingsLoadAction->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TAppMainForm::SaveSettings()
{
	SettingsSaveAction->Execute();
}
//---------------------------------------------------------------------------

