//---------------------------------------------------------------------------
#ifndef App_SettingsHandlerH
#define App_SettingsHandlerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "App_Handlers.h"
#include "Moa_TypedLists.h"
//---------------------------------------------------------------------------
namespace App_settingshandler {
//---------------------------------------------------------------------------
class TSettingsHandler : public THandler
{
private:
	static const AnsiString File;
	TTypedObjectList<THandler>* FHandlers;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	__property TTypedObjectList<THandler>* Handlers = {read=FHandlers};
protected:
public:
	__fastcall TSettingsHandler();
	virtual __fastcall ~TSettingsHandler();
	virtual void __fastcall Load();
	virtual bool __fastcall CanLoad();
	virtual void __fastcall Save();
	virtual bool __fastcall CanSave();
	virtual void __fastcall Register(THandler* AHandler);
	virtual void __fastcall LoadSettings(TMemIniFile* AFile);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile);
};
//---------------------------------------------------------------------------
} // End namespace App_settingshandler
using namespace App_settingshandler;
//---------------------------------------------------------------------------
#endif

