//---------------------------------------------------------------------------
#ifndef App_ToolsHandlerH
#define App_ToolsHandlerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "App_Handlers.h"
//---------------------------------------------------------------------------
namespace App_toolshandler {
//---------------------------------------------------------------------------
struct TToolsOptions
{
	AnsiString EditorFile;
	bool __fastcall operator ==(const TToolsOptions& AOther) const;
	bool __fastcall operator !=(const TToolsOptions& AOther) const;
};
//---------------------------------------------------------------------------
class TToolsHandler : public THandler
{
private:
	static const AnsiString TemplateFile;
	TToolsOptions FOptions;
	TSaveDialog* FTemplateSaveDialog;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	__property TSaveDialog* TemplateSaveDialog = {read=FTemplateSaveDialog};
protected:
public:
	__fastcall TToolsHandler();
	virtual __fastcall ~TToolsHandler();
	virtual void __fastcall OpenWithEditor(const AnsiString& AFile);
	virtual bool __fastcall CanOpenWithEditor();
	virtual void __fastcall CreateTemplate();
	virtual bool __fastcall CanCreateTemplate();
	virtual void __fastcall SetOptions(const TToolsOptions& AOptions);
	virtual bool __fastcall CanSetOptions();
	virtual void __fastcall ShowOptions();
	virtual bool __fastcall CanShowOptions();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile);
	__property TToolsOptions Options = {read=FOptions};
};
//---------------------------------------------------------------------------
} // End namespace App_toolshandler
using namespace App_toolshandler;
//---------------------------------------------------------------------------
#endif

