//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_ViewDialog.h"
#include "Moa_AutoPointers.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppViewDialog* AppViewDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::Field22Click(TObject* ASender)
{
	ColorDialog1->Color = Input22;
	if(!ColorDialog1->Execute()) {
		Abort();
	}
	Input22 = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::Field23Click(TObject* ASender)
{
	ColorDialog1->Color = Input23;
	if(!ColorDialog1->Execute()) {
		Abort();
	}
	Input23 = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::Field24Click(TObject* ASender)
{
	FontDialog1->Font = Input24;
	if(!FontDialog1->Execute()) {
		Abort();
	}
	Input24 = FontDialog1->Font;
}
//---------------------------------------------------------------------------
TAppViewDialog* __fastcall TAppViewDialog::EnsureCreated()
{
	if(AppViewDialog == NULL) {
		AppViewDialog = new TAppViewDialog(Application);
	}
	return AppViewDialog;
}
//---------------------------------------------------------------------------
TViewOptions __fastcall TAppViewDialog::GetDefaultValues()
{
	TViewOptions LValues;
	LValues.ControlOptions.ShowToolbar = false;
	LValues.ControlOptions.ShowStatusBar = false;
	LValues.MessageOptions.BackgroundColor = clBlack;
	LValues.MessageOptions.ForegroundColor = clBlack;
	LValues.MessageOptions.FontName = AnsiString();
	LValues.MessageOptions.FontStyles = TFontStyles();
	LValues.MessageOptions.FontSize = 0;
	return LValues;
}
//---------------------------------------------------------------------------
TViewOptions __fastcall TAppViewDialog::GetInputs()
{
	TViewOptions LInputs = Values;
	LInputs.ControlOptions.ShowToolbar = Input11;
	LInputs.ControlOptions.ShowStatusBar = Input12;
	LInputs.MessageOptions.BackgroundColor = Input22;
	LInputs.MessageOptions.ForegroundColor = Input23;
	LInputs.MessageOptions.FontName = Input24->Name;
	LInputs.MessageOptions.FontStyles = Input24->Style;
	LInputs.MessageOptions.FontSize = Input24->Size;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::SetInputs(const TViewOptions& AInputs)
{
	Input11 = AInputs.ControlOptions.ShowToolbar;
	Input12 = AInputs.ControlOptions.ShowStatusBar;
	Input22 = AInputs.MessageOptions.BackgroundColor;
	Input23 = AInputs.MessageOptions.ForegroundColor;
	Input24->Name = AInputs.MessageOptions.FontName;
	Input24->Style = AInputs.MessageOptions.FontStyles;
	Input24->Size = AInputs.MessageOptions.FontSize;
}
//---------------------------------------------------------------------------
bool __fastcall TAppViewDialog::GetInput11()
{
	return Field11->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::SetInput11(bool AInput11)
{
	Field11->Checked = AInput11;
}
//---------------------------------------------------------------------------
bool __fastcall TAppViewDialog::GetInput12()
{
	return Field12->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::SetInput12(bool AInput12)
{
	Field12->Checked = AInput12;
}
//---------------------------------------------------------------------------
TColor __fastcall TAppViewDialog::GetInput22()
{
	return Field21->Color;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::SetInput22(TColor AInput22)
{
	Field21->Color = AInput22;
}
//---------------------------------------------------------------------------
TColor __fastcall TAppViewDialog::GetInput23()
{
	return Field21->Font->Color;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::SetInput23(TColor AInput23)
{
	Field21->Font->Color = AInput23;
}
//---------------------------------------------------------------------------
TFont* __fastcall TAppViewDialog::GetInput24()
{
	return Field21->Font;
}
//---------------------------------------------------------------------------
void __fastcall TAppViewDialog::SetInput24(TFont* AInput24)
{
	Field21->Font = AInput24;
}
//---------------------------------------------------------------------------
__fastcall TAppViewDialog::TAppViewDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(GetDefaultValues())
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppViewDialog::~TAppViewDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TAppViewDialog::Execute()
{
	Inputs = Values;
	ActiveControl = NULL;
	SelectFirst();
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

