//---------------------------------------------------------------------------
#ifndef App_ViewHandlerH
#define App_ViewHandlerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include "App_Handlers.h"
namespace Comctrls { class TStatusBar; } using namespace Comctrls;
namespace Comctrls { class TToolBar; } using namespace Comctrls;
namespace Stdctrls { class TStaticText; } using namespace Stdctrls;
//---------------------------------------------------------------------------
namespace App_viewhandler {
//---------------------------------------------------------------------------
struct TControlOptions
{
	bool ShowToolbar;
	bool ShowStatusBar;
	bool __fastcall operator ==(const TControlOptions& AOther) const;
	bool __fastcall operator !=(const TControlOptions& AOther) const;
};
//---------------------------------------------------------------------------
struct TMessageOptions
{
	TColor BackgroundColor;
	TColor ForegroundColor;
	AnsiString FontName;
	TFontStyles FontStyles;
	int FontSize;
	bool __fastcall operator ==(const TMessageOptions& AOther) const;
	bool __fastcall operator !=(const TMessageOptions& AOther) const;
};
//---------------------------------------------------------------------------
struct TViewOptions
{
	TControlOptions ControlOptions;
	TMessageOptions MessageOptions;
	bool __fastcall operator ==(const TViewOptions& AOther) const;
	bool __fastcall operator !=(const TViewOptions& AOther) const;
};
//---------------------------------------------------------------------------
class TViewHandler : public THandler
{
private:
	TForm* FForm;
	TToolBar* FToolbar;
	TStatusBar* FStatusBar;
	TStaticText* FStaticText;
	TControlOptions __fastcall GetControlOptions();
	TMessageOptions __fastcall GetMessageOptions();
	TViewOptions __fastcall GetViewOptions();
	__property TForm* Form = {read=FForm};
	__property TToolBar* Toolbar = {read=FToolbar};
	__property TStatusBar* StatusBar = {read=FStatusBar};
	__property TStaticText* StaticText = {read=FStaticText};
protected:
public:
	__fastcall TViewHandler(TForm* AForm, TToolBar* AToolbar, TStatusBar* AStatusBar, TStaticText* AStaticText);
	virtual __fastcall ~TViewHandler();
	virtual void __fastcall SetControlOptions(const TControlOptions& AControlOptions);
	virtual bool __fastcall CanSetControlOptions();
	virtual void __fastcall SetMessageOptions(const TMessageOptions& AMessageOptions);
	virtual bool __fastcall CanSetMessageOptions();
	virtual void __fastcall SetViewOptions(const TViewOptions& AViewOptions);
	virtual bool __fastcall CanSetViewOptions();
	virtual void __fastcall Customize();
	virtual bool __fastcall CanCustomize();
	virtual void __fastcall LoadSettings(TMemIniFile* AFile);
	virtual void __fastcall SaveSettings(TMemIniFile* AFile);
	__property TControlOptions ControlOptions = {read=GetControlOptions};
	__property TMessageOptions MessageOptions = {read=GetMessageOptions};
	__property TViewOptions ViewOptions = {read=GetViewOptions};
};
//---------------------------------------------------------------------------
} // End namespace App_viewhandler
using namespace App_viewhandler;
//---------------------------------------------------------------------------
#endif

