//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <ComCtrls.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
#include "App_Views.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace App_views {
//---------------------------------------------------------------------------
AnsiString __fastcall TMainView::GetCaption()
{
	return Form->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TMainView::SetCaption(const AnsiString& ACaption)
{
	Form->Caption = ACaption;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainView::GetText()
{
	return StaticText->Caption;
}
//---------------------------------------------------------------------------
void __fastcall TMainView::SetText(const AnsiString& AText)
{
	StaticText->Caption = AText;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMainView::GetStatus()
{
	return StatusBar->SimpleText;
}
//---------------------------------------------------------------------------
void __fastcall TMainView::SetStatus(const AnsiString& AStatus)
{
	StatusBar->SimpleText = AStatus;
}
//---------------------------------------------------------------------------
__fastcall TMainView::TMainView(TForm* AForm, TStaticText* AStaticText, TStatusBar* AStatusBar) :
	TObject(),
	FForm(AForm),
	FStaticText(AStaticText),
	FStatusBar(AStatusBar)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TMainView::~TMainView()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TMainView::WriteLine(const AnsiString& AText)
{
	Text = Text + AText + "\r\n";
}
//---------------------------------------------------------------------------
void __fastcall TMainView::WriteBlankLine()
{
	WriteLine(AnsiString());
}
//---------------------------------------------------------------------------
void __fastcall TMainView::Clear()
{
	Text = AnsiString();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::DoInvalidate()
{
	if(OnInvalidate != NULL) {
		OnInvalidate(this);
	}
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::DoUpdate()
{
	if(OnUpdate != NULL) {
		OnUpdate(this);
	}
}
//---------------------------------------------------------------------------
__fastcall TUpdateNotifier::TUpdateNotifier() :
	TObject(),
	FInvalidated(false),
	FOnInvalidate(NULL),
	FOnUpdate(NULL)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TUpdateNotifier::~TUpdateNotifier()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Invalidate()
{
	if(Invalidated) {
		return;
	}
	FInvalidated = true;
	DoInvalidate();
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Update()
{
	if(!Invalidated) {
		return;
	}
	FInvalidated = false;
	DoUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TUpdateNotifier::Refresh()
{
	FInvalidated = false;
	DoUpdate();
}
//---------------------------------------------------------------------------
} // End of namespace App_views
//---------------------------------------------------------------------------

