//---------------------------------------------------------------------------
#ifndef App_ViewsH
#define App_ViewsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Comctrls { class TStatusBar; } using namespace Comctrls;
namespace Comctrls { class TToolBar; } using namespace Comctrls;
namespace Forms { class TForm; } using namespace Forms;
namespace Stdctrls { class TStaticText; } using namespace Stdctrls;
//---------------------------------------------------------------------------
namespace App_views {
//---------------------------------------------------------------------------
class TMainView : public TObject
{
private:
	TForm* FForm;
	TStaticText* FStaticText;
	TStatusBar* FStatusBar;
	AnsiString __fastcall GetCaption();
	void __fastcall SetCaption(const AnsiString& ACaption);
	AnsiString __fastcall GetText();
	void __fastcall SetText(const AnsiString& AText);
	AnsiString __fastcall GetStatus();
	void __fastcall SetStatus(const AnsiString& AStatus);
	__property TForm* Form = {read=FForm};
	__property TStaticText* StaticText = {read=FStaticText};
	__property TStatusBar* StatusBar = {read=FStatusBar};
protected:
public:
	__fastcall TMainView(TForm* AForm, TStaticText* AStaticText, TStatusBar* AStatusBar);
	virtual __fastcall ~TMainView();
	virtual void __fastcall WriteLine(const AnsiString& AText);
	virtual void __fastcall WriteBlankLine();
	virtual void __fastcall Clear();
	__property AnsiString Caption = {read=GetCaption, write=SetCaption};
	__property AnsiString Text = {read=GetText, write=SetText};
	__property AnsiString Status = {read=GetStatus, write=SetStatus};
};
//---------------------------------------------------------------------------
class TUpdateNotifier : public TObject
{
private:
	bool FInvalidated;
	TNotifyEvent FOnInvalidate;
	TNotifyEvent FOnUpdate;
protected:
	virtual void __fastcall DoInvalidate();
	virtual void __fastcall DoUpdate();
public:
	__fastcall TUpdateNotifier();
	virtual __fastcall ~TUpdateNotifier();
	virtual void __fastcall Invalidate();
	virtual void __fastcall Update();
	virtual void __fastcall Refresh();
	__property bool Invalidated = {read=FInvalidated};
	__property TNotifyEvent OnInvalidate = {read=FOnInvalidate, write=FOnInvalidate};
	__property TNotifyEvent OnUpdate = {read=FOnUpdate, write=FOnUpdate};
};
//---------------------------------------------------------------------------
} // End of namespace App_views
using namespace App_views;
//---------------------------------------------------------------------------
#endif

