//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_FileDrop.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Version: 1.0+1.0
// Date: 2011-11-30 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include "Moa_AutoPointers.h"
//---------------------------------------------------------------------------
namespace Moa_filedrop {
//---------------------------------------------------------------------------
TPoint __fastcall TFileDrop::GetPoint()
{
	if(IsFinished()) {
		throw EFileDropError("The program cannot get the point where the files are dropped.");
	}
	TPoint LPoint(0, 0);
	::DragQueryPoint(Handle, &LPoint);
	return LPoint;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFileDrop::GetFile(int AIndex)
{
	if(IsFinished() || AIndex < 0 || AIndex >= Count) {
		throw EFileDropError("The program cannot get the path of the dropped file.");
	}
	UINT LBufferSize = ::DragQueryFile(Handle, AIndex, NULL, 0) + 1;
	TAutoArray<TCHAR> LBuffer = new TCHAR[LBufferSize];
	UINT LDataLength = ::DragQueryFile(Handle, AIndex, LBuffer, LBufferSize);
	return AnsiString(LBuffer, LDataLength);
}
//---------------------------------------------------------------------------
int __fastcall TFileDrop::GetCount()
{
	if(IsFinished()) {
		throw EFileDropError("The program cannot get the number of the dropped files.");
	}
	return ::DragQueryFile(Handle, 0xFFFFFFFF, NULL, 0);
}
//---------------------------------------------------------------------------
__fastcall TFileDrop::TFileDrop(const TMessage& AMessage, bool AAutoFinish) :
	FHandle(NULL),
	FAutoFinish(AAutoFinish)
{
	if(AMessage.Msg != WM_DROPFILES) {
		throw EFileDropError("The program cannot make a  of the file drop.");
	}
	FHandle = reinterpret_cast<HDROP>(AMessage.WParam);
}
//---------------------------------------------------------------------------
__fastcall TFileDrop::~TFileDrop()
{
	if(AutoFinish) {
		Finish();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileDrop::Finish()
{
	if(IsFinished()) {
		return;
	}
	::DragFinish(Handle);
	FHandle = NULL;
}
//---------------------------------------------------------------------------
bool __fastcall TFileDrop::IsFinished()
{
	return FHandle == NULL;
}
//---------------------------------------------------------------------------
} // End namespace Moa_filedrop
//---------------------------------------------------------------------------

