//---------------------------------------------------------------------------
#ifndef Moa_FileDropH
#define Moa_FileDropH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
// Version: 1.0+1.0
// Date: 2011-11-30 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
namespace Moa_filedrop {
//---------------------------------------------------------------------------
class EFileDropError : public Exception
{
public:
	__fastcall EFileDropError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TFileDrop
{
private:
	HDROP FHandle;
	bool FAutoFinish;
	__fastcall TFileDrop(const TFileDrop& ASource);
		// Forbidden
	TFileDrop& __fastcall operator =(const TFileDrop& ASource);
		// Forbidden
	TPoint __fastcall GetPoint();
	AnsiString __fastcall GetFile(int AIndex);
	int __fastcall GetCount();
protected:
public:
	__fastcall TFileDrop(const TMessage& AMessage, bool AAutoFinish = false);
	virtual __fastcall ~TFileDrop();
	virtual void __fastcall Finish();
	virtual bool __fastcall IsFinished();
	__property HDROP Handle = {read=FHandle};
	__property TPoint Point = {read=GetPoint};
	__property AnsiString Files[int AIndex] = {read=GetFile};
	__property int Count = {read=GetCount};
	__property bool AutoFinish = {read=FAutoFinish, write=FAutoFinish};
};
//---------------------------------------------------------------------------
} // End namespace Moa_filedrop
using namespace Moa_filedrop;
//---------------------------------------------------------------------------
#endif

