//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-12-13 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Moa_Forms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
namespace Moa_forms {
//---------------------------------------------------------------------------
TRect __fastcall TFormUtilities::GetNormalBounds(TForm* AForm)
{
	return GetPlacement(AForm).rcNormalPosition;
}
//---------------------------------------------------------------------------
void __fastcall TFormUtilities::SetNormalBounds(TForm* AForm, const TRect& ABounds)
{
	WINDOWPLACEMENT LPlacement = GetPlacement(AForm);
	LPlacement.rcNormalPosition = ABounds;
	SetPlacement(AForm, LPlacement);
}
//---------------------------------------------------------------------------
TPoint __fastcall TFormUtilities::GetNormalPosition(TForm* AForm)
{
	WINDOWPLACEMENT LPlacement = GetPlacement(AForm);
	return TPoint(LPlacement.rcNormalPosition.left, LPlacement.rcNormalPosition.top);
}
//---------------------------------------------------------------------------
void __fastcall TFormUtilities::SetNormalPosition(TForm* AForm, const TPoint& APosition)
{
	WINDOWPLACEMENT LPlacement = GetPlacement(AForm);
	LPlacement.rcNormalPosition = Bounds(
		APosition.x,
		APosition.y,
		TRect(LPlacement.rcNormalPosition).Width(),
		TRect(LPlacement.rcNormalPosition).Height());
	SetPlacement(AForm, LPlacement);
}
//---------------------------------------------------------------------------
WINDOWPLACEMENT __fastcall TFormUtilities::GetPlacement(TForm* AForm)
{
	WINDOWPLACEMENT LPlacement = {0};
	LPlacement.length = sizeof(WINDOWPLACEMENT);
	if(!::GetWindowPlacement(AForm->Handle, &LPlacement)) {
		throw EInvalidOperation("The program could not get the placement of the form.");
	}
	return LPlacement;
}
//---------------------------------------------------------------------------
void __fastcall TFormUtilities::SetPlacement(TForm* AForm, const WINDOWPLACEMENT& APlacement)
{
	if(!::SetWindowPlacement(AForm->Handle, &APlacement)) {
		throw EInvalidOperation("The program could not set the placement of the form.");
	}
}
//---------------------------------------------------------------------------
} // End namespace Moa_forms
//---------------------------------------------------------------------------

