//---------------------------------------------------------------------------
#ifndef Moa_SetsH
#define Moa_SetsH
//---------------------------------------------------------------------------
// Version: 1.0.0 +
// Date: 2012-02-03 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_sets {
//---------------------------------------------------------------------------
class ESetError : public Exception
{
public:
	__fastcall ESetError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
template <typename T, unsigned char MinElement, unsigned char MaxElement>
class TSetUtilities
{
private:
protected:
public:
	typedef Set<T, MinElement, MaxElement> TSet;
	static TSet __fastcall FromString(const AnsiString& AString)
	{
		TSet LSet;
		for(unsigned char LI = MinElement; LI <= MaxElement; ++LI) {
			if(LI >= AString.Length()) {
				break;
			}
			if(AString[LI + 1] != '0') {
				LSet << static_cast<T>(LI);
			}
		}
		return LSet;
	}
	static AnsiString __fastcall ToString(const TSet& ASet)
	{
		AnsiString LString = AnsiString::StringOfChar('0', MaxElement + 1);
		for(unsigned char LI = MinElement; LI <= MaxElement; ++LI) {
			if(ASet.Contains(static_cast<T>(LI))) {
				LString[LI + 1] = '1';
			}
		}
		return LString;
	}
};
//---------------------------------------------------------------------------
} // End namespace Moa_sets
using namespace Moa_sets;
//---------------------------------------------------------------------------
#endif

