//---------------------------------------------------------------------------
#ifndef Moa_TypedListsH
#define Moa_TypedListsH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2011-11-26 UTC+09:00
// Status: Beta
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_typedlists {
//---------------------------------------------------------------------------
template <typename T>
class TTypedList : public TList
{
private:
	T* __fastcall GetItem(int AIndex);
	void __fastcall SetItem(int AIndex, T* AItem);
protected:
public:
	__fastcall TTypedList();
	virtual __fastcall ~TTypedList();
	T* operator[](int AIndex);
	HIDESBASE int __fastcall Add(T* AItem);
	HIDESBASE void __fastcall Insert(int AIndex, T* AItem);
	HIDESBASE T* __fastcall Extract(T* AItem);
	HIDESBASE int __fastcall Remove(T* AItem);
	HIDESBASE TTypedList<T>* __fastcall Expand();
	HIDESBASE T* __fastcall First();
	HIDESBASE T* __fastcall Last();
	HIDESBASE int __fastcall IndexOf(T* AItem);
	__property T* Items[int AIndex] = {read=GetItem, write=SetItem};
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
template <typename T>
class TTypedObjectList : public TObjectList
{
private:
	T* __fastcall GetTypedItem(int AIndex);
	void __fastcall SetTypedItem(int AIndex, T* AItem);
protected:
public:
	__fastcall TTypedObjectList();
	__fastcall TTypedObjectList(bool AOwnsObjects);
	virtual __fastcall ~TTypedObjectList();
	T* operator[](int AIndex);
	HIDESBASE int __fastcall Add(T* AItem);
	HIDESBASE void __fastcall Insert(int AIndex, T* AItem);
	HIDESBASE T* __fastcall Extract(T* AItem);
	HIDESBASE int __fastcall Remove(T* AItem);
	HIDESBASE TTypedList<T>* __fastcall Expand();
	HIDESBASE T* __fastcall First();
	HIDESBASE T* __fastcall Last();
	HIDESBASE int __fastcall IndexOf(T* AItem);
	__property T* Items[int AIndex] = {read=GetTypedItem, write=SetTypedItem};
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedList<T>::GetItem(int AIndex)
{
	return static_cast<T*>(TList::Items[AIndex]);
}
//---------------------------------------------------------------------------
template <typename T>
void __fastcall TTypedList<T>::SetItem(int AIndex, T* AItem)
{
	TList::Items[AIndex] = AItem;
}
//---------------------------------------------------------------------------
template <typename T>
__fastcall TTypedList<T>::TTypedList() :
	TList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
template <typename T>
__fastcall TTypedList<T>::~TTypedList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
template <typename T>
T* TTypedList<T>::operator[](int AIndex)
{
	return Items[AIndex];
}
//---------------------------------------------------------------------------
template <typename T>
int __fastcall TTypedList<T>::Add(T* AItem)
{
	return TList::Add(AItem);
}
//---------------------------------------------------------------------------
template <typename T>
void __fastcall TTypedList<T>::Insert(int AIndex, T* AItem)
{
	TList::Insert(AIndex, AItem);
}
//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedList<T>::Extract(T* AItem)
{
	return static_cast<T*>(TList::Extract(AItem));
}
//---------------------------------------------------------------------------
template <typename T>
int __fastcall TTypedList<T>::Remove(T* AItem)
{
	return TList::Remove(AItem);
}
//---------------------------------------------------------------------------
template <typename T>
TTypedList<T>* __fastcall TTypedList<T>::Expand()
{
	return static_cast<TTypedList<T>*>(TList::Expand());
}
//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedList<T>::First()
{
	return static_cast<T*>(TList::First());
}
//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedList<T>::Last()
{
	return static_cast<T*>(TList::Last());
}
//---------------------------------------------------------------------------
template <typename T>
int __fastcall TTypedList<T>::IndexOf(T* AItem)
{
	return TList::IndexOf(AItem);
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedObjectList<T>::GetTypedItem(int AIndex)
{
	return static_cast<T*>(TObjectList::Items[AIndex]);
}
//---------------------------------------------------------------------------
template <typename T>
void __fastcall TTypedObjectList<T>::SetTypedItem(int AIndex, T* AItem)
{
	TObjectList::Items[AIndex] = AItem;
}
//---------------------------------------------------------------------------
template <typename T>
__fastcall TTypedObjectList<T>::TTypedObjectList() :
	TObjectList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
template <typename T>
__fastcall TTypedObjectList<T>::TTypedObjectList(bool AOwnsObjects) :
	TObjectList(AOwnsObjects)
{
	// Do nothing
}
//---------------------------------------------------------------------------
template <typename T>
__fastcall TTypedObjectList<T>::~TTypedObjectList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
template <typename T>
T* TTypedObjectList<T>::operator[](int AIndex)
{
	return static_cast<T*>(Items[AIndex]);
}
//---------------------------------------------------------------------------
template <typename T>
int __fastcall TTypedObjectList<T>::Add(T* AItem)
{
	return TObjectList::Add(AItem);
}
//---------------------------------------------------------------------------
template <typename T>
void __fastcall TTypedObjectList<T>::Insert(int AIndex, T* AItem)
{
	TObjectList::Insert(AIndex, AItem);
}
//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedObjectList<T>::Extract(T* AItem)
{
	return static_cast<T*>(TObjectList::Extract(AItem));
}
//---------------------------------------------------------------------------
template <typename T>
int __fastcall TTypedObjectList<T>::Remove(T* AItem)
{
	return TObjectList::Remove(AItem);
}
//---------------------------------------------------------------------------
template <typename T>
TTypedList<T>* __fastcall TTypedObjectList<T>::Expand()
{
	return static_cast<TTypedObjectList<T>*>(TObjectList::Expand());
}
//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedObjectList<T>::First()
{
	return static_cast<T*>(TObjectList::First());
}
//---------------------------------------------------------------------------
template <typename T>
T* __fastcall TTypedObjectList<T>::Last()
{
	return static_cast<T*>(TObjectList::Last());
}
//---------------------------------------------------------------------------
template <typename T>
int __fastcall TTypedObjectList<T>::IndexOf(T* AItem)
{
	return TObjectList::IndexOf(AItem);
}
//---------------------------------------------------------------------------
} // End namespace Moa_typedlists
using namespace Moa_typedlists;
//---------------------------------------------------------------------------
#endif

